//
//  MasterViewController.swift
//  NoteApp-iPad-Ia
//
//  Created by Henry Liu on 8/28/14.
//  Copyright (c) 2014 Henry Liu. All rights reserved.
//

import UIKit

class MasterViewController: UITableViewController {

    var detailViewController: DetailViewController? = nil
    var objects = NSMutableArray()
    var siteNames = NSMutableArray ()
    var siteUrls = NSMutableArray ()

    override func awakeFromNib() {
        super.awakeFromNib()
        self.clearsSelectionOnViewWillAppear = false
        self.preferredContentSize = CGSize(width: 320.0, height: 600.0)
    }

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        self.navigationItem.leftBarButtonItem = self.editButtonItem()

        let addButton = UIBarButtonItem(barButtonSystemItem: .Add, target: self, action: "insertNewObject:")
        self.navigationItem.rightBarButtonItem = addButton
        
        
        // add custom code
        siteNames = ["Apple", "Google", "Amazon"]
        siteUrls = ["http://www.apple.com", "http://www.google.com", "http://www.amazon.com"]
/*
        if let controllers = self.splitViewController.viewControllers {
        self.detailViewController = controllers[controllers.count-1].topViewController as? DetailViewController
    }
    */
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    func insertNewObject(sender: AnyObject) {
        if objects.count == 0 {
            objects = NSMutableArray()
        }
        objects.insertObject(NSDate.date(), atIndex: 0)
        let indexPath = NSIndexPath(forRow: 0, inSection: 0)
        self.tableView.insertRowsAtIndexPaths([indexPath], withRowAnimation: .Automatic)
    }

    // MARK: - Segues

    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        if segue.identifier == "showDetail" {
            println ("\nMasterView: call prepareForSegue...")
            if let indexPath = self.tableView.indexPathForSelectedRow() {
            //let object = objects[indexPath.row] as NSDate
            let object = siteUrls[indexPath.row] as String
            let controller = (segue.destinationViewController as UINavigationController).topViewController as DetailViewController
            controller.detailItem = object
            controller.navigationItem.leftBarButtonItem = self.splitViewController?.displayModeButtonItem()
            controller.navigationItem.leftItemsSupplementBackButton = true
            }
            
            /*
            if siteUrls.count > 0 {
                let urlString: String = siteUrls.objectAtIndex(indexPath.row) as String
                println ("web view: \(urlString)")
                let urlPath = NSURL (string: urlString)
                let request: NSURLRequest = NSURLRequest (URL: urlPath)
                self.detailViewController?.webView.scalesPageToFit = true
                self.detailViewController?.webView.loadRequest(request)
            } else {
                println ("siteUrls is empty")
            }
*/

        }
    }

    // MARK: - Table View

    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        return 1
    }

    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        //return objects.count
        return siteNames.count
    }

    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCellWithIdentifier("Cell", forIndexPath: indexPath) as UITableViewCell

        //let object = objects[indexPath.row] as NSDate
        //cell.textLabel.text = object.description
        cell.textLabel?.text = siteNames[indexPath.row] as? String
        return cell
    }

    override func tableView(tableView: UITableView, canEditRowAtIndexPath indexPath: NSIndexPath) -> Bool {
        // Return false if you do not want the specified item to be editable.
        return true
    }

    override func tableView(tableView: UITableView, commitEditingStyle editingStyle: UITableViewCellEditingStyle, forRowAtIndexPath indexPath: NSIndexPath) {
        if editingStyle == .Delete {
            objects.removeObjectAtIndex(indexPath.row)
            tableView.deleteRowsAtIndexPaths([indexPath], withRowAnimation: .Fade)
        } else if editingStyle == .Insert {
            // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
        }
    }
/*
    override func tableView (tableView: UITableView!, didSelectRowAtIndexPath indexPath: NSIndexPath!) {
        if siteUrls.count > 0 {
        let urlString: String = siteUrls.objectAtIndex(indexPath.row) as String
        println (urlString)
        let urlPath = NSURL (string: urlString)
        let request: NSURLRequest = NSURLRequest (URL: urlPath)
        self.detailViewController?.webView.scalesPageToFit = true
        self.detailViewController?.webView.loadRequest(request)
        } else {
                println ("siteUrls is empty")
            }
    }
*/
}

